
## adam 2014-2017

## Select Codec
##codec=`osascript -e 'display dialog "Select Codec:" default answer "Customs Commands" with title "adam | 2015" buttons ["XviD", "x264", "x265"] default button 2 with icon file ((path to home folder as string) & "Library:Services:EncoDam.workflow:Contents:EncoDam.app:Contents:Resources:applet.icns")' 2>&1` && echo "$codec" > /tmp/EncoDam.codecs

## Paths & Variables
f=`cat /tmp/EncoDam.tmp`
codec=`tr ' ' '\n' < /tmp/EncoDam.codecs` #By List use "$codec" & By Line use $codec
codecs=`echo $codec | cut -d':' -f2-2 | cut -d',' -f1`
moviename=`echo $f | rev | cut -d'/' -f1 | rev`
end=`echo $f | rev | cut -d'.' -f 2- | rev`
ffmpeg=~/Library/Services/EncoDam.workflow/Contents/ffmpeg
SublerCLI=~/Library/Services/EncoDam.workflow/Contents/SublerCLI
Notify=~/Library/Services/EncoDam.workflow/Contents/EncoDam.app/Contents/MacOS/EncoDam
group=`echo $((RANDOM%10+0))`
log=~/Library/Logs/adam-EncoDam.log
echo "$f" > /tmp/EncoDam.tmp

## Rotating && Logs
tail -n 5000 ~/Library/Logs/adam-EncoDam.log > ~/Library/Logs/adam-EncoDam-new.log
mv ~/Library/Logs/adam-EncoDam-new.log ~/Library/Logs/adam-EncoDam.log
echo ""						>> $log
echo ""						>> $log
echo "-------------------------------------------------------------------------------------------------------------------------------------" >> $log
echo ""						>> $log
echo `date`	>> $log ; echo ''	>> $log
echo "=-> EncoDam Source:" "$f" >> $log
echo Video Source: `$ffmpeg -i "$f" 2>&1 | grep ": Video:" | grep fps | grep -v 'mjpeg\|png'` >> $log
echo Audio Source: `$ffmpeg -i "$f" 2>&1 | grep ": Audio:"` >> $log
echo `$ffmpeg -i "$f" 2>&1 | grep 'Duration'` >> $log
echo ""						>> $log


### Video Copy or Check
echo "=-> EncoDam Video Config"  >> $log
if echo $codec | grep copyvideo ; then
	vcodec="-c:v copy"
	echo ByPass: copyvideo 	>> $log
else
	echo 'Codec Video:' $codecs >> $log
	## Preset
	if echo $codec | grep preset ; then
		preset=`echo $codec | cut -d'_' -f2 | cut -d" " -f1`
		echo 'Preset:' $preset >> $log
	else
		if echo $codec | grep XviD ; then preset=veryslow ; fi
		if echo $codec | grep x264 ; then preset=slower ; fi
		if echo $codec | grep x265 ; then preset=medium ; fi
		echo 'Preset:' $preset >> $log
	fi

	## Aspect Forced
		if echo $codec | grep aspect ; then
		aspect1=`echo $codec | grep 'aspect' | cut -d'/' -f1 | rev | cut -d' ' -f1 | rev`
		aspect2=`echo $codec | grep 'aspect' | cut -d'/' -f2 | cut -d' ' -f1`
		aspect=`echo -aspect $aspect1:$aspect2`
		echo 'Aspect Forced:' $aspect >> $log
	fi

	## Check Size
	Size=`$ffmpeg -i "$f" 2>&1 | grep Video | grep -v 'mjpeg\|png' | tr ' ' '\n' | grep x | grep -v ')' | cut -d'x' -f1`

	## Custom Resize & Crop
	if echo $codec | grep resize ; then
		resizes=`echo $codec | cut -d'=' -f2-3 | cut -d" " -f1`
		resize=`echo '-vf scale='${resizes}` 
		echo 'Custom Crop:' $resizes >> $log
		Size=`echo $resizes | cut -d':' -f1`
	fi

	## Easy Scale
	if echo $codec | grep scale ; then
		scales=`echo $codec | cut -d'=' -f2-3 | cut -d" " -f1`
		scale=`echo '-vf scale='${scales}':-2'` 
		echo 'Easy Video Scale:' $scales >> $log
		Size=`echo $scales`
	fi

	## Quality ßy Size
	# 4K True & TV
	if echo $Size | awk '{if ($1 >= 4096) print $1, "is = or greater than 4096" }' | grep greater ; then crf=24 ; vb=4M ; bf=40M ; mr=20M ; vbv=42000 ; vbvmax=5000 ; fi
	# 2500 2K
	if echo $Size | awk '{if ($1 <= 2500) print $1, "is = or smaller than 2500" }' | grep smaller ; then crf=23 ; vb=2.5M ; bf=25M ; mr=7.5M ; vbv=35000 ; vbvmax=4000 ; fi
	# 1920 HD2
	if echo $Size | awk '{if ($1 <= 1920) print $1, "is = or smaller than 1920" }' | grep smaller ; then crf=23 ; vb=1.9M ; bf=19M ; mr=6M ; vbv=60000 ; vbvmax=3500 ; fi
	# 1280 HD
	if echo $Size | awk '{if ($1 <= 1280) print $1, "is = or smaller than 1280" }' | grep smaller ; then crf=22 ; vb=1.2M ; bf=17M ; mr=5M ; vbv=40000 ; vbvmax=2500 ; fi
	# 1024 DVD
	if echo $Size | awk '{if ($1 <= 1024) print $1, "is = or smaller than 1024" }' | grep smaller ; then crf=21 ; vb=1M ; bf=10M ; mr=4M ; vbv=34000 ; vbvmax=2000 ; fi
	# 960 Small HD
	if echo $Size | awk '{if ($1 <= 960) print $1, "is = or smaller than 1024" }' | grep smaller ; then crf=21 ; vb=0.8M ; bf=9M ; mr=3.5M ; vbv=9000 ; vbvmax=1500 ; fi
	# 720 DV
	if echo $Size | awk '{if ($1 <= 720) print $1, "is = or smaller than 720" }' | grep smaller ; then crf=20 ; vb=0.7M ; bf=7M ; mr=1.4M ; vbv=7200 ; vbvmax=1200 ; fi
	# 640 VGA
	if echo $Size | awk '{if ($1 <= 640) print $1, "is = or smaller than 640" }' | grep smaller ; then crf=20 ; vb=0.6M ; bf=6M ; mr=1.2M ; vbv=6000 ; vbvmax=1000 ; fi
	# 520
	if echo $Size | awk '{if ($1 <= 520) print $1, "is = or smaller than 600" }' | grep smaller ; then crf=19 ; vb=0.5M ; bf=5M ; mr=1M ; vbv=6000 ; vbvmax=1000 ; fi
	# 480
	if echo $Size | awk '{if ($1 <= 480) print $1, "is = or smaller than 480" }' | grep smaller ; then crf=19 ; vb=0.4M ; bf=4M ; mr=0.8M ; vbv=4800 ; vbvmax=800 ; fi
	# 320
	if echo $Size | awk '{if ($1 <= 320) print $1, "is = or smaller than 320" }' | grep smaller ; then crf=19 ; vb=0.3M ; bf=3M ; mr=0.6M ; vbv=4000 ; vbvmax=800 ; fi

	## VBV-Buffer Flex (Last Fix :09/08/2017)
	if echo "$codec" | grep vbvmax= ; then vbvmax=`echo "$codec" | grep vbvmax= | cut -d'=' -f2` ; fi
	vbv=`echo ${vbvmax} *50 | bc`

	## Customs Commands
	if echo "$codec" | grep smooth ; then smooth="-rc_eq 'blurCplx^(1-qComp)'" ; fi
	if echo "$codec" | grep denoize ; then denoize="-vf 'hqdn3d=1.5:1.5:6:6'" ; fi
	if echo "$codec" | grep tune= ; then tune=`echo "$codec" | grep tune= | cut -d'=' -f2` ; tunes=`echo -tune ${tune}` ; fi
		if echo "$codec" | grep x265 ; echo "$codec" | grep grain ; then grainextra=`echo ":rc-grain"` ; else grainextra=`echo ""` ; fi
		if echo "$codec" | grep x265 ; then crf=`echo ${crf} -2 | bc`; fi
		if echo "$codec" | grep x265 ; echo "$codec" | grep fast ; then sao=`echo ":limit-sao"` ; else sao=`echo ""` ; fi ## x265 fast limit-sao (process based on inter prediction mode, CTU spatial-domain correlations, and relations between luma and chroma)
		#if echo "$codec" | grep x265 ; echo "$codec" | grep slow ; then sao=`echo ":limit-sao"` ; else sao=`echo ""` ; fi ## x265 fast limit-sao (process based on inter prediction mode, CTU spatial-domain correlations, and relations between luma and chroma)
		if echo "$codec" | grep x265 ; echo "$codec" | grep 2pass ; then twopass="pass=1:no-slow-firstpass=1:" ; else twopass='' ; fi
	if echo "$codec" | grep allmap ; then allmap="-map 0" ; fi
	if echo "$codec" | grep stereo ; then ac=-ac 2 ; fi
	if echo "$codec" | grep lowaudio ; then ab=96K ; fi 
	if echo "$codec" | grep highaudio ; then ab=320K ; fi 
	if echo "$codec" | grep ab= ; then ab=`echo "$codec" | grep ab= | cut -d'=' -f2` ; fi
	if echo "$codec" | grep vb= ; then vb=`echo "$codec" | grep vb= | cut -d'=' -f2` ; fi
	if echo "$codec" | grep crf= ; then crf=`echo "$codec" | grep crf= | cut -d'=' -f2` ; fi
	#if echo "$codec" | grep vbvmax= ; then vbvmax=`echo "$codec" | grep vbvmax= | cut -d'=' -f2` ; fi
	#if echo "$codec" | grep vbvmax= ; then vbv=`echo ${vbvmax} *25 | bc` ; fi
	if echo "$codec" | grep 'vp9\|VP9' ; then codecs=vp9 ; fi
	if echo "$codec" | grep DVD ; then codecs=DVD ; extension=mpg ; else extension=mkv ; fi
	if echo "$codec" | grep MPEG2 ; then codecs=MPEG2 ; extension=mpg ; else extension=mkv ; fi
	if echo "$codec" | grep mov ; then codecs=mov ; fi
	if echo "$codec" | grep Quicktime ; then Quicktime="-pix_fmt yuv444p" ; fi
	if echo "$codec" | grep color= ; then color=`echo "$codec" | grep color= | cut -d'=' -f2` ; colors=`echo -pix_fmt ${color}` ; fi
	FastStart="-movflags +faststart" # Optimize for Web
	echo $extension > /tmp/EncoDam.ext

	# Video Config Logs
	echo CRF: $crf >> $log
	#echo Bitrate: $vb >> $log
	#echo Max Bitrate: $mr >> $log
	#echo Buffer: $bf >> $log
	echo VBV-bufsize: $vbv >> $log
	echo VBV-maxrate: $vbvmax >> $log

	if echo "$codec" | grep color= ; then echo color: ${colors} >> $log ; fi

	## Custom Bitrate
	if echo "$codec" | grep vb= ; then vb=`echo "$codec" | grep vb= | cut -d'=' -f2` ; echo Custom Video Bitrate: $vb >> $log ; fi

	## Check Crop
	if echo $codec | grep autocrop ; then
		$Notify -title 'Check Crop' -message "$moviename" -execute 'afplay /System/Library/Sounds/Pop.aiff' -group $group
		#fullcrop="-vf scale=$Size:-2,`$cat | $ffmpeg -i "$f" -an -vf 'scale='$Size':-2,cropdetect' -f null - 2>&1 | awk '/crop/ { print $NF }' | tail -1`"
		crop="-vf scale=$Size:-2,`$cat | $ffmpeg -i -ss 00:03:00 "$f" -vframes 25 -preset ultrafast -an -sn -t 120 -vf 'scale='$Size':-2,cropdetect' -f null - 2>&1 | awk '/crop/ { print $NF }' | tail -1`"
		echo AutoCrop: $crop >> $log
	scale='' ## Fix AutoCrop Priority to Scale
	fi

	if echo $codec | grep 'resize\|DVD' ; then echo 'Crop:' nocrop >> $log ; fi

	## Check Interlace
	if echo $codec | grep deinterlace ; then echo "Interlace: deinterlace" >> $log ; deinterlace="-deinterlace" ; fi

	## Video Options
	if echo $codec | grep XviD ; then vcodec="-c:v libxvid -preset $preset -cmp chroma -mbd 2 -aq-mode 2 -me_method hex -qscale 3.7 -minrate 0.2M -b:v $vb -maxrate $mr -bufsize $bf" ; fi
	if echo $codec | grep x264 ; then vcodec="-c:v libx264 -preset $preset -mbd 2 -x264-params "crf=${crf}:vbv-bufsize=${vbv}:vbv-maxrate=${vbvmax}:qcomp=0.9:psy-rd=0.7:b-adapt=2" " ; fi
	#if echo $codec | grep x265 ; then vcodec="-c:v libx265 -preset $preset -mbd 2 -x265-params crf=${crf}:limit-tu=4:tu-inter-depth=2:weightb:analyze-src-pics:constrained-intra$sao:refine-level$grainextra -qmin 5 -qmax 25 -b:v $vb -maxrate $mr -bufsize $bf" ; fi
	if echo $codec | grep x265 ; then vcodec="-c:v libx265 -preset $preset -mbd 2 -x265-params "${twopass}crf=${crf}:vbv-bufsize=${vbv}:vbv-maxrate=${vbvmax}:qcomp=0.9:ssim-rd=1:psy-rdoq=1:rdoq-level=1:psy-rd=0.7:dynamic-rd=4:aq-mode=2:b-intra=1:b-adapt=2:weightb=1:weightp=1:analyze-src-pics=1:constrained-intra=1:colormatrix=bt709:colorprim=bt709:transfer=bt709$sao$grainextra" " ; fi ## ColorFix + Grain
	#if echo $codec | grep 2pass ; then vcodec1="-c:v libx265 -preset $preset -mbd 2 -x265-params "$2pass:crf=${crf}:vbv-bufsize=${vbv}:vbv-maxrate=${vbvmax}:qcomp=0.9:ssim-rd=1:psy-rdoq=1:rdoq-level=1:psy-rd=0.7:dynamic-rd=4:aq-mode=2:b-intra=1:b-adapt=2:weightb=1:weightp=1:analyze-src-pics=1:constrained-intra=1:colormatrix=bt709:colorprim=bt709:transfer=bt709$sao$grainextra" " ; fi ## ColorFix + Grain
	#if echo $codec | grep DVD ; then vcodec="-target pal-dvd -g 15 -cmp 2 -subcmp 2 -me_method epzs -qscale 2 -trellis 2 -cmp chroma -minrate 0.2M -b:v $vb -maxrate 12M" ; fi
	#if echo $codec | grep DVD ; then DVDcrop='-vf "scale=iw*sar:ih , pad=max(iw\,ih*(16/9)):ow/(16/9):(ow-iw)/2:(oh-ih)/2" -aspect 16:9' ; fi
	if echo $codec | grep MPEG2 ; then vcodec="-c:v mpeg2video -preset $preset -cmp chroma -trellis 2 -bf 2 -bt 300k -cmp 2 -subcmp 2 -me_method epzs -mbd 2 -aq-strength 1.6 -aq-mode 2 -qmin 1 -qscale 2 -minrate 0.2M -b:v $vb -maxrate 12M -bufsize $bf" ; fi
	if echo $codec | grep vp9 ; then vcodec="-c:v libvpx-vp9 -threads 12 -speed 2 -tile-columns 6 -frame-parallel 1 -auto-alt-ref 1 -lag-in-frames 25 -preset $preset -cmp chroma -mbd 2 -aq-strength 1.6 -aq-mode 2 -crf $crf -qmax 38 -minrate 0.2M -b:v $vb -maxrate $mr -bufsize $bf" ; fi
fi


### Audio Copy or Check
echo '' >> $log ; echo "=-> EncoDam Audio Config"  >> $log
if echo $codec | grep copyaudio ; then
	acodec="copy"
	ba=''
	echo 'ByPass:' copyaudio 	>> $log
else
	ba='-b:a'
	# Audio Options
	if echo "$codec" | grep aac ; then acodec="aac" ; else acodec="libfdk_aac" ; fi
	if echo "$codec" | grep 'DVD\|MPEG2' ; then acodec="ac3" ; fi
	if echo "$codec" | grep XviD ; then acodec="libmp3lame" ; fi
	echo 'Codec:' $acodec			>> $log

	## Audio Check DVDInfo Fr 
	if cat "${end}.txt" | grep fr ; then
		$Notify -title EncoDam 'Check DVDInfo Fr' -message "$moviename"
		if cat "${end}.txt" | grep 'audio\|fr\|stereo' ; then nbfr="$(echo `cat "${end}.txt" | grep 'audio\|fr\|stereo' | cut -d' ' -f3-3` + 1 | bc)" ; fi   
		if cat "${end}.txt" | grep 'audio\|fr\|5.1' ; then nbfr="$(echo `cat "${end}.txt" | grep 'audio\|fr\|5.1' | cut -d' ' -f3-3` + 1 | bc)" ; fi
		fr=`echo -map 0:${nbfr}`
		vd=`echo -map 0:0`
		sn=`echo -sn` 
		echo ''					 	>> $log
		echo 'Sound Map:' $fr 		>> $log
		echo 'Sound Source:' `$ffmpeg -i "$f" 2>&1 | grep 0:${nbfr}` >> $log
	fi
	
	## Copy Subtitles
	if echo $codec | grep copysub ; then copysub='-c:s copy' ; fi


	if echo $codec | grep 'lowaudio\|highaudio\|ab=' ; then
		echo Custom Audio Bitrate: $ab >> $log
	else
	## Audio Check
	if echo "$codec" | grep stereo ; then MultiChanel='Not5.1' ; echo 'Audio: Force Stereo' >> $log ; else MultiChanel='.1' ; fi
		if $ffmpeg -i "$f" 2>&1 | grep Stream | grep "$MultiChanel" | grep 0:${nbfr} ; then ab=256K
			echo 'Sound: 5.1 or 7.1' $ab >> $log
		else
			abs=`$ffmpeg -i "$f" 2>&1 | grep Stream | grep Audio | rev | cut -d' ' -f 2 | rev | grep [0-9]`
			if echo $abs | awk '{if ($1 >= 250) print $1, "is = or greater than 250" }' | grep greater ; then ab=256K ; fi
			if echo $abs | awk '{if ($1 >= 140) print $1, "is = or greater than 150" }' | grep greater ; then ab=160K ; fi
			if echo $abs | awk '{if ($1 <= 120) print $1, "is = or smaller than 130" }' | grep smaller ; then ab=128K ; fi
			if echo $abs | awk '{if ($1 <= 90) print $1, "is = or smaller than 100" }' | grep smaller | grep -v '' ; then ab=96K ; fi
			if echo $abs | awk '{if ($1 <= 64) print $1, "is = or smaller than 64" }' | grep smaller | grep -v '' ; then ab=64K ; fi
			if echo "$codec" | grep stereo ; then ab=160K ; fi
			echo 'Sound: stereo' $ab >> $log
		fi
	fi

	## Check Normalize
	if echo $codec | grep normalize ; then
		$Notify -title 'EncoDam Check Normalize' -message "$moviename" -group $group
		VolumeCheck=`$ffmpeg -i "$f" -vn -sn -af volumedetect -f null - 2>&1 | grep max_volume | cut -d':' -f2 | cut -d' ' -f2`
		if echo $VolumeCheck | grep '-'; then
			Normalize="-af volume=`echo $VolumeCheck | cut -d'-' -f2`"
		if echo $VolumeCheck | grep '0.0'; then Normalize="" ; fi
		fi
			echo Volume Checked: $VolumeCheck		>> $log
			echo Normalisation: $Normalize 			>> $log
	fi
fi

### EncoDam Begin
echo '' >> $log ; echo "=-> EncoDam is Begin" >> $log

## Check DVD Chapters
if cat "${end}.txt" | grep MPX_CHAPTERINFO ; then cat "${end}.txt" | grep MPX_CHAPTERINFO= | cut -d'=' -f2 | tr ',' '\n' | sed 's/$/ Chapter/' | sed = | sed 'N;s/\n/ /' | awk '{t=$1;$1=$NF;$NF=t}1' | cut -d' ' -f2-3 | sed 's/ / Chapter /g' > "${end}.Chapters.txt"; fi

## EncoDam-Progress 10.10
echo $codecs > /tmp/EncoDam.codec ; rm ~/ffmpeg-*.log ; sleep 1
open ~/Library/Services/EncoDam.workflow/Contents/EncoDam-Progress.app

## Encod DVD
if echo $codecs | grep DVD ; then
	$Notify -title "$codecs EncoD Begin…" -message "$moviename.EncoDam-$codecs.$extension" -execute 'afplay /System/Library/Sounds/Pop.aiff' -group $group
	caffeinate $ffmpeg -report $file -i "$f" \
	$smooth $denoize $deinterlace -metadata encoded_by="EncoDam-DVD" \
	$vd -target pal-dvd -g 15 -cmp 2 -subcmp 2 -me_method epzs -qscale 2 -trellis 2 -cmp chroma -minrate 0.2M -b:v $vb -maxrate 12M -vf "scale=iw*sar:ih , pad=max(iw\,ih*(16/9)):ow/(16/9):(ow-iw)/2:(oh-ih)/2" -aspect 16:9 \
	$fr -c:a $acodec -b:a 320k \
	$FastStart $Normalize -y $allmap "${end}.EncoDam-DVD.mpg"
fi

## Encod or Copy MPEG2, XviD, x264, x265, vp9
if echo $codecs | grep 'MPEG2\|XviD\|x264\|x265\|vp9' ; then
	if echo $codec | grep '2pass' ; then echo ''
	else
	$Notify -title "$codecs EncoD Begin…" -message "$moviename.EncoDam-$codecs.$extension" -execute 'afplay /System/Library/Sounds/Pop.aiff' -group $group
	caffeinate $ffmpeg -report $file -i "$f" \
	$smooth $denoize $deinterlace $tunes -metadata encoded_by="EncoDam-$codecs" $sn \
	$vd $vcodec $DVDcrop $crop $resize $scale $aspect $colors $Quicktime \
	$fr -c:a $acodec $ba $ab $ac \
	$FastStart $Normalize -y $allmap $copysub "${end}.EncoDam-$codecs.$extension"
	fi
fi

## Encod 2pass or Copy MPEG2, XviD, x264, x265, vp9
if echo $codecs | grep 'MPEG2\|XviD\|x264\|x265\|vp9' ; then
	if echo $codec | grep '2pass' ; then
	$Notify -title "$codecs 2pass EncoD Begin…" -message "$moviename.EncoDam-$codecs.$extension" -execute 'afplay /System/Library/Sounds/Pop.aiff' -group $group
	# First Pass
	caffeinate $ffmpeg -report $file -i "$f" \
	$smooth $denoize $deinterlace $tunes -metadata encoded_by="EncoDam-$codecs"  $sn \
	$vd $vcodec $DVDcrop $crop $resize $scale $aspect $colors $Quicktime \
	$fr -c:a $acodec $ba $ab $ac \
	$FastStart $Normalize -y $allmap $copysub "${end}.EncoDam-$codecs.$extension" \
	# Second Pass
	vcodec2=`echo $vcodec | sed 's/no-slow-firstpass=1://g' | sed 's/pass=1/pass=2/g'`
	caffeinate $ffmpeg -report $file -i "$f" \
	$smooth $denoize $deinterlace $tunes -metadata encoded_by="EncoDam-$codecs" $sn \
	$vd $vcodec2 $DVDcrop $crop $resize $scale $aspect $colors $Quicktime \
	$fr -c:a $acodec $ba $ab $ac \
	$FastStart $Normalize -y $allmap $copysub "${end}.EncoDam-$codecs.$extension"
	fi
fi

## Merge DVD Chapters & Optimize
if cat "${end}.Chapters.txt" ; then
	echo 'EncoDam is Merging' >> $log
	$Notify -title EncoDam 'Merge DVD Chapters' -message "$moviename" -execute 'afplay /System/Library/Sounds/Pop.aiff' -group $group
	
	## Copy Streams LossLess
	$ffmpeg -i "${end}.EncoDam.mkv" -c copy -f mp4 $FastStart -y "${end}.EncoDam.mp4"
	if test -f "${end}.EncoDam.mp4" ; then rm "${end}.EncoDam.mkv"; fi
	 
	$SublerCLI -source "${end}.EncoDam.mp4" -chapters "${end}.Chapters.txt" -optimize -dest "${end}.EncoDam+Chap.mp4" -group $group
	rm "${end}.EncoDam.mp4"
	rm "${end}.Chapters.txt"
fi

head -42 ~/ffmpeg-*.log >> $log

### END
killall applet
Time="$(echo 'obase=60;'$SECONDS | bc | sed 's/ /:/g' | cut -c 2-)"
FFLogs=`cd ~/ ; grep -lr "$end" *.log`

echo ""		>> $log
echo "=-> EndoDam is Done in" $Time's'	>> $log
echo "Outpout: ${end}.EncoDam-$codecs.$extension" >> $log
echo Video: `$ffmpeg -i "${end}.EncoDam-$codecs.$extension" 2>&1 | grep ": Video:"` >> $log
echo Audio: `$ffmpeg -i "${end}.EncoDam-$codecs.$extension" 2>&1 | grep ": Audio:"` >> $log
echo `$ffmpeg -i "${end}.EncoDam-$codecs.$extension" 2>&1 | grep 'Duration'` >> $log ; echo ""		>> $log
$Notify -title "$codecs Done in ${Time}s" -message "$moviename.EncoDam-$codecs.$extension" -execute 'afplay /System/Library/Sounds/Bottle.aiff' -group $group
rm $FFLogs ; afplay /System/Library/Sounds/Bottle.aiff
